=== debian/changelog ===
ros-kinetic-teb-local-planner (0.6.14-1xenial) xenial; urgency=high

  * Rename variable instead of scoping it's usage
  * test_optim_node fix circular obstacles (thanks to dtaranta)
  * Fix shadow variable warning (thanks to Victor Lopez)
  * Use SYSTEM when including external dependencies headers (thanks to Victor Lopez)
  * Limiting the control look-ahead pose to the first that execeeds the expected look-ahead time (thanks to Marco Bassa)
  * Adding the option to shift ahead the target pose used to extract the velocity command (thanks to Marco Bassa)
  * Fixed segfault in optimal_planner.cpp when clearing graph with unallocated optimizer.
    Fixes #158 <https://github.com/rst-tu-dortmund/teb_local_planner/issues/158>.
  * Added warning if parameter optimal_time is <= 0
  * Nonlinear obstacle cost from EdgeInflatedObstacle also added to EdgeObstacle.
    See #140 <https://github.com/rst-tu-dortmund/teb_local_planner/issues/140>.
  * Fixed proper initialization of parameter obstacle_cost_exponent in case it is not loaded from the parameter server
  * Contributors: Christoph Rösmann, Marco Bassa, Victor Lopez, dtaranta

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Thu, 24 Oct 2019 22:00:00 -0000

ros-kinetic-teb-local-planner (0.6.13-1xenial) xenial; urgency=high

  * Avoiding h signature interpolation between coincident poses (thanks to Marco Bassa)
  * New strategy for the deletion of detours: Detours are now determined w.r.t. the least-cost alternative and not w.r.t. just the goal heading.
    Deletion of additional alternatives applies if either an initial backward motion is detected, if the transition time is much bigger than the duration of the best teb
    and if a teb cannot be optimized (thanks to Marco Bassa).
    Optionally allowing the usage of the initial plan orientation when initializing new tebs.
  * Contributors: Christoph Rösmann, Marco Bassa

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Sun, 30 Jun 2019 22:00:00 -0000

ros-kinetic-teb-local-planner (0.6.12-1xenial) xenial; urgency=high

  * Allow scripts to be executable and usable by rosrun after catkin_make install and through the catkin release process (thanks to Devon Ash)
  * Add nonlinear part to obstacle cost to improve narrow gap behavior.
    Parameter obstacle_cost_exponent defines the exponent of the nonlinear cost term.
    The default linear behavior is achieved by setting this parameter to 1 (default).
    A value of 4 performed well in some tests and experiments (thanks to Howard Cochran).
  * Parameter global_plan_prune_distance added via ros parameter server.
  * Fixed SIGSEGV in optimizeAllTEBs() if main thread is interrupted by boost (thanks to Howard Cochran)
  * Fixed SIGSEGV crash in deleteTebDetours() (thanks to Howard Cochran)
  * On footprint visualization, avoid overshadowing by obstacles (thanks to corot)
  * Do not ignore robot model on the association stage.
    Important mostly for polygon footprint model (thanks to corot).
  * Adjustable color for footprint visualization
  * Showing (detected) infeasible robot poses in a separate marker namespace and color
  * Added edge for minimizing Euclidean path length (parameter: weight_shortest_path)
  * Ackermann steering conversion (python script): fixed direction inversion in backwards mode when cmd_angle_instead_rotvel is true (thanks to Tobi Loew)
  * Fixed wrong skipping condition in AddEdgesKinematicsCarlike() (thanks to ShiquLIU)
  * Never discarding the previous best teb in renewAndAnalyzeOldTebs (thanks to Marco Bassa)
  * Allowing for the fallback to a different trajectory when the costmap check fails. This prevents the switch to unfeasible trajectories (thanks to Marco Bassa).
  * Skipping the generation of the homotopy exploration graph in case the maximum number of allowed classes is reached (thanks to Marco Bassa)
  * Changed isTrajectoryFeasible function to allow for a more accurate linear and angular discretization (thanks to Marco Bassa)
  * Function TebOptimalPlanner::computeError() considers now the actual optimizer weights.
    As a result, the default value of selection_obst_cost_scale is reduced (thanks to Howard Cochran).
  * Contributors: Christoph Rösmann, Devon Ash, Howard Cochran, Marco Bassa, ShiquLIU, Tobi Loew, corot

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Thu, 20 Jun 2019 22:00:00 -0000

ros-kinetic-teb-local-planner (0.6.11-1xenial) xenial; urgency=high

  * bugfix in calculateHSignature. Fixes #90.
  * fixed centroid computation in a special case of polygon-obstacles
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Mon, 13 Aug 2018 22:00:00 -0000

ros-kinetic-teb-local-planner (0.6.10-1xenial) xenial; urgency=high

  * Parameter switching_blocking_period added to homotopy class planner parameter group.
    Values greater than zero enforce the homotopy class planner to only switch to new equivalence classes as soon
    as the given period is expired (this might reduce oscillations in some scenarios). The value is set to zero seconds
    by default in order to not change the behavior of existing configurations.
  * Fixed unconsistent naming of parameter global_plan_viapoint_sep.
    The parameter retrieved at startup was global_plan_via_point_sep and via dynamic_reconfigure it was global_plan_viapoint_sep.
    global_plan_via_point_sep has now been replaced by global_plan_viapoint_sep since this is more consistent with the variable name
    in the code as well as weight_viapoint and the ros wiki description.
    In order to not break things, the old parameter name can still be used. However, a deprecated warning is printed.
  * transformGlobalPlan searches now for the closest point within the complete subset of the global plan in the local costmap:
    In every sampling interval, the global plan is processed in order to find the closest pose to the robot (as reference start)

